Bug 135396 - yum update fails with conflicts after fc3t3 x86_64 install
yum update fails with conflicts after fc3t3 x86_64 install
Status: CLOSED UPSTREAM
Product: Fedora
Classification: Fedora
Component: yum (Show other bugs)
3
ia32e Linux
medium Severity medium
: ---
: ---
Assigned To: Jeremy Katz
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2004-10-12 10:36 EDT by Thomas J. Baker
Modified: 2014-01-21 17:50 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-10-28 18:08:26 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
full output (261.79 KB, text/plain)
2004-10-12 13:23 EDT, Thomas J. Baker
no flags Details
full debug 10 output (307.07 KB, text/plain)
2004-10-12 13:25 EDT, Thomas J. Baker
no flags Details
potential solution (6.36 KB, text/plain)
2004-10-28 14:54 EDT, Seth Vidal
no flags Details
fix for updates and ia32e (22.60 KB, text/plain)
2004-10-28 15:36 EDT, Seth Vidal
no flags Details
fix for ia32e basearch detection (6.45 KB, text/plain)
2004-10-28 15:51 EDT, Seth Vidal
no flags Details
update with fix for multlib arch traversal for ia32e (22.95 KB, text/plain)
2004-10-28 17:32 EDT, Seth Vidal
no flags Details
patch to fix all the problems listed here. Patch is against yum 2.1.11 (3.12 KB, patch)
2004-10-28 18:12 EDT, Seth Vidal
no flags Details | Diff
fix for installation of noarch packages (663 bytes, patch)
2004-10-30 23:35 EDT, Seth Vidal
no flags Details | Diff

  None (edit)
Description Thomas J. Baker 2004-10-12 10:36:50 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; rv:1.7.3) Gecko/20041008
Firefox/0.10.1

Description of problem:
I just did an fc3t3 install on a Dell 1850 dual CPU x86_64 system. I
then tried to do a yum update and got massive file confilcts along
these lines:

...
                [u] system-config-users.noarch 0:1.2.24-1 - user
                [u] tcp_wrappers.i386 0:7.6-37.2 - user
                [u] tzdata.noarch 0:2004e-2 - user
                [u] valgrind.i386 1:2.2.0-3 - user
                [u] xinitrc.noarch 0:4.0.13-1 - user
Is this ok [y/N]: y
Running Transaction Test
Finished Transaction Test
Transaction Check Error:   file
/usr/share/man/man3/Image::Magick.3pm.gz from install of
ImageMagick-6.0.7.1-4 conflicts with file from package
ImageMagick-6.0.7.1-3
  file /usr/share/man/man1/curl.1.gz from install of curl-7.12.1-1
conflicts with file from package curl-7.12.0-4
  file /usr/bin/mysql_config from install of mysql-3.23.58-12
conflicts with file from package mysql-3.23.58-10
  file /usr/bin/mysqlbug from install of mysql-3.23.58-12 conflicts
with file from package mysql-3.23.58-10
  file /usr/bin/mysqld_multi from install of mysql-3.23.58-12
conflicts with file from package mysql-3.23.58-10
  file /usr/bin/mysqlhotcopy from install of mysql-3.23.58-12
conflicts with file from package mysql-3.23.58-10
  file /usr/share/man/man1/c2ph.1.gz from install of perl-5.8.5-6
conflicts with file from package perl-5.8.5-4
  file /usr/share/man/man1/cpan.1.gz from install of perl-5.8.5-6
conflicts with file from package perl-5.8.5-4
  file /usr/share/man/man1/dprofpp.1.gz from install of perl-5.8.5-6
conflicts with file from package perl-5.8.5-4
  file /usr/share/man/man1/enc2xs.1.gz from install of perl-5.8.5-6
conflicts with file from package perl-5.8.5-4
  file /usr/share/man/man1/find2perl.1.gz from install of perl-5.8.5-6
conflicts with file from package perl-5.8.5-4
  file /usr/share/man/man1/h2ph.1.gz from install of perl-5.8.5-6
conflicts with file from package perl-5.8.5-4
  file /usr/share/man/man1/h2xs.1.gz from install of perl-5.8.5-6
conflicts with file from package perl-5.8.5-4

I then updated just glibc and yum by hand (rpm -Fvh) but still have
the same conflicts. It must be confusion over the dual arches? 

Version-Release number of selected component (if applicable):
yum-2.1.6-1.noarch.rpm

How reproducible:
Didn't try


Additional info:

Didn't try to reproduce it since I would need another x86_64 platform
to try it on.
Comment 1 Seth Vidal 2004-10-12 10:38:40 EDT
You cut out a portion of the output.

what was ABOVE the ...?

I need to see which ImageMagick part.

But if I had to guess I'd say you had a non-elf file conflict from two
multilib packages.
Comment 2 Bill Nottingham 2004-10-12 12:10:13 EDT
However, it appears to be conflicting on different versions of all the
packages... the multiarch versions *should* be in sync in the repository.
Comment 3 Seth Vidal 2004-10-12 13:05:09 EDT
which is why I'd like to see the full output from the command, and not
just part of it.

Comment 4 Thomas J. Baker 2004-10-12 13:23:50 EDT
Created attachment 105080 [details]
full output
Comment 5 Thomas J. Baker 2004-10-12 13:25:45 EDT
Created attachment 105081 [details]
full debug 10 output
Comment 6 Seth Vidal 2004-10-12 13:59:20 EDT
where are you getting this repository from? 

Is this one you're making yourself or is it just from an rsync? 

Could you include the primary.xml.gz from the repository?

thanks
Comment 7 Thomas J. Baker 2004-10-12 14:05:12 EDT
I'm running from a local rsync mirror of mirror.linux.duke.edu. I
can't include the file because bugzilla says it's too large but you
can get it from
http://yum.sr.unh.edu/fedora/development/x86_64/repodata/primary.xml.gz

Comment 8 Seth Vidal 2004-10-12 14:15:48 EDT
Do you mirror AND run createrepo?

I ask b/c your primary.xml.gz doesn't match the one on
mirror.linux.duke.edu.

The real thing I'm wondering is: do you mirror the data then make it
into a repo on your own? If so I think you got caught b/t two syncs of
the rpms and got half in and half out of the packages.
Comment 9 Thomas J. Baker 2004-10-12 14:22:54 EDT
No, I just mirror. Maybe my mirror is not complete for x86_64? I just
tried to mirror again to see if there were any updates but it failed
connection.

Another strange thing I noticed is that when I run a yum update from
the x86_64 machine, it gets the two i386 repodata files (these are
http logs):

132.177.241.84 - - [12/Oct/2004:14:19:16 -0400] "GET
/fedora/development/i386/repodata/repomd.xml HTTP/1.1" 200 1084
132.177.241.84 - - [12/Oct/2004:14:19:16 -0400] "GET
/fedora/test/2.92/i386/os/repodata/repomd.xml HTTP/1.1" 200 1084

Does that make sense?

Yum conf line looks like this:

baseurl=http://yum/fedora/development/$basearch/

Comment 10 Thomas J. Baker 2004-10-12 14:25:04 EDT
FWIW, my rsync at 11:13am didn't get any files so it seems like my
mirror is up to date.
Comment 11 Seth Vidal 2004-10-12 14:29:27 EDT
This is confusing, then.

B/c it would make sense that they'd be the same but I checked the path
and your checksums are not the same, the file size it not the same and
the last change of the x86_64 path was this morning at 7am, so it's
hard for me to understand how you could have the same files but not
have the same xml files or datestamps.

What path are you rsyncing?
Comment 12 Thomas J. Baker 2004-10-12 15:20:02 EDT
#!/bin/csh -x

set MIRRORDIR="/space/ftp/redhat"
set MIRROR="mirror.linux.duke.edu"

#########################################################################
#
# Mirroring Fedora Development
#
#########################################################################

rsync --timeout=60  -az -v --delete
${MIRROR}::fedora-linux-core-development/ $MIRRORDIR/fedora/development

Comment 13 Thomas J. Baker 2004-10-12 15:26:36 EDT
I just pointed it at
baseurl=http://mirror.linux.duke.edu/pub/fedora/linux/core/development/$basearch/
 and have the same errors.
Comment 14 Seth Vidal 2004-10-12 15:32:43 EDT
okay - this was a fresh install of x86_64 fedora core 3 test 3, right?

b/c I'm looking at this tree and all the packages match - so it's
beginning to look like a packaging problem.

Could you run the following commands:
yum list installed curl
yum list installed mysql\*
yum list installed perl

thanks
Comment 15 Thomas J. Baker 2004-10-12 15:37:07 EDT
Fresh install this morning.

[root@nocona ~]# yum list installed curl
Installed Packages
curl.i386                                7.12.0-4               installed
curl.x86_64                              7.12.0-4               installed
[root@nocona ~]# yum list installed mysql\*
Installed Packages
mysql.i386                               3.23.58-10             installed
mysql.x86_64                             3.23.58-10             installed
[root@nocona ~]# yum list installed perl
Installed Packages
perl.x86_64                              3:5.8.5-4              installed
perl.i386                                3:5.8.5-4              installed
[root@nocona ~]#
Comment 16 Seth Vidal 2004-10-12 15:39:27 EDT
what does /etc/rpm/macros 

have in it?
Comment 17 Thomas J. Baker 2004-10-12 15:43:19 EDT
There is no single /etc/rpm/macros file but four macros. files:

[root@nocona ~]# cat /etc/rpm/macros.
macros.jpackage  macros.prelink   macros.specspo   macros.up2date
[root@nocona ~]# cat /etc/rpm/macros.jpackage
#
# RPM macros for Java applications.
#
# JPackage Project  <http://www.jpackage.org/>
#   David Walluck   <david@anti-microsoft.org>
#   Ville Skyttä    <ville.skytta@iki.fi>
#   Nicolas Mailhot <Nicolas.Mailhot@laPoste.net>
#
# $Id: macros.jpackage,v 1.1.2.5 2003/08/30 13:24:58 scop Exp $
#

#==============================================================================
# ---- default Java directories

#
# Root directory where all Java VMs/SDK/JREs are installed.
#
%_jvmdir        %{_prefix}/lib/jvm

#
# Root directory where all Java VMs/SDK/JREs expose their jars
#
%_jvmjardir     %{_prefix}/lib/jvm-exports

#
# Root directory for all Java VM/SDK/JRE's private things.
#
%_jvmprivdir    %{_prefix}/lib/jvm-private

#
# Directory where arch and version independent jars are installed.
# This has already been integrated in RH macros following our request.
#
# By extension:
# %{_javadir}-ext:
#   - version dependent jars
# %{_javadir}-x.y.z:
#   - jars for Java standard x.y.z (usually symlinks to  %{_javadir}-ext)
# %{_javadir}-utils:
#   - Java-related scripts
#
# To simplify things only %{_javadir} is defined.
#
%_javadir        %{_datadir}/java

#
# Directory where arch-specific (JNI) version-independent jars are
installed.
#
# By extension:
# %{_jnidir}-ext:
#   - version dependent jars
# %{_jnidir}-x.y.z:
#   - jars for Java standard x.y.z (usually symlinks to  %{_jnidir}-ext)
# To simplify things only %{_jnidir} is defined.
#
%_jnidir        %{_prefix}/lib/java

#
# Root directory where all javadoc is installed. Also already in RH
macros.
#
%_javadocdir     %{_datadir}/javadoc

#
# Current default JVM home.
#
%java_home      %(. %{_javadir}-utils/java-functions; set_jvm; echo
$JAVA_HOME)

#==============================================================================
# ---- default Java commands

%ant            JAVA_HOME=%{java_home} ant
%jar            %{java_home}/bin/jar
%java           %(. %{_javadir}-utils/java-functions; set_javacmd;
echo $JAVACMD)
%javac          %{java_home}/bin/javac
%javadoc        %{java_home}/bin/javadoc

#==============================================================================
# ---- Java extension handling macros

#
# add_jvm_extension should be used in %install by extension packages
to declare
# what extension jars they provide.
#
# For example a package that provides foo.jar which is the bar extension
# under java 1.2 and 1.3 should do a:
#
#   %install
#   ... # create foo.jar in %{javadir}-ext
#   %add_jvm_extension  foo bar 1.2 1.3
#
#   %files
#   %{javadir}-ext/foo.jar
#   %{javadir}-*/bar.jar
#
%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir}
%{_bindir}/jvmjar -l

#==============================================================================
# ---- default icons directories as per the icon theme freedesktop spec

%_iconstheme    hicolor
%_iconsbasedir  %{_datadir}/icons/%{_iconstheme}

#
# The following is a bit heavy and will be removed
#
%_icons16dir    %{_iconsbasedir}/16x16/apps
%_icons22dir    %{_iconsbasedir}/22x22/apps
%_icons48dir    %{_iconsbasedir}/48x48/apps
%_icons64dir    %{_iconsbasedir}/64x64/apps
%_icons96dir    %{_iconsbasedir}/96x96/apps
%_icons192dir   %{_iconsbasedir}/192x192/apps
%_iconsscaldir  %{_iconsbasedir}/scalable/apps

#
# Mandrake macros for non-Mandrake systems.
#
%_miconsdir     %{!?%_miconsdir:%{_datadir}/icons/mini}
%_iconsdir      %{!?%_iconsdir:%{_datadir}/icons}
%_liconsdir     %{!?%_liconsdir:%{_datadir}/icons/large}


#
# Mandrake icons
#
# %1    the name of the icon (typically the name of the package). Mandrake
#       requires 3 icons sizes (48, 32, 16), all should be present.
#
%mdkicons() \
install -D -m 644 %1-48.png $RPM_BUILD_ROOT%{_liconsdir}/%1.png\
install -D -m 644 %1-32.png $RPM_BUILD_ROOT%{_iconsdir}/%1.png\
install -D -m 644 %1-16.png $RPM_BUILD_ROOT%{_miconsdir}/%1.png


#
# Red Hat icons
#
# %1    the name of the icon (typically the name of the package). RedHat
#       requires 3 icons sizes (48, 32, 16), all should be present.
%rhicons() \
install -D -m 644 %1-48.png
$RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps/%{name}.png\
install -D -m 644 %1-32.png
$RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps/%{name}.png\
install -D -m 644 %1-16.png
$RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps/%{name}.png


#==============================================================================
# ---- default .desktop directories per the desktop-entry
freedesktop.org spec

%_desktopdir    %{_datadir}/applications

#
# Mandrake menu dir
#
%_menudir       %{!?%_menudir:%{_prefix}/lib/menu}

#
# Mandrake menu
#
# %1    the name of the menu (ex: %{name})
# %2    the command to run (ex: %{_bindir}/%{name})
# %3    needs (ex: X11)
# %4    menu section (ex: Applications/Editors)
# %5    mime types (ex: text/html;text/plain)
# %6    menu title (ex: %{name})
# %7    comment or summary (ex: %{Summary})
# %8    icon (ex: %{name}.png)
# %9    unused
#
%mdkmenu() \
install -d -m 755 $RPM_BUILD_ROOT%{_menudir}\
cat >$RPM_BUILD_ROOT%{_menudir}/%1 <<EOF\
\?package(%1):\\
 command="%2"\\
 needs="%3"\\
 section="%4"\\
 mimetypes="%5"\\
 title="%6"\\
 longtitle="%7"\\
 icon="%8"\\
EOF

%post_mdkmenu\
%post mdkmenu\
%{update_menus}

%postun_mdkmenu\
%postun mdkmenu\
%{clean_menus}

#
# Legacy menu
#
# %1    the name of the menu (ex: %{name})
# %2    the command to run (ex: %{_bindir}/%{name})
# %3    needs (ex: 1)
# %4    menu section (ex: Development)
# %5    unused
# %6    menu title (ex: %{name})
# %7    comment or summary (ex: %{Summary})
# %8    icon (ex: %{name}.png)
# %9    type (ex: Application)
#
Comment 18 Seth Vidal 2004-10-12 15:45:25 EDT
this will be a problem.

for fun - make an /etc/rpm/macros file

and put this in it:
%_transaction_color   3


then rerun things
see if it works.
Comment 19 Thomas J. Baker 2004-10-12 15:50:08 EDT
I added the file but I get the same error.
Comment 20 Seth Vidal 2004-10-12 15:51:25 EDT
so you didn't have an /etc/rpm/macros file at all, then?

grep for 'transaction' in any of the other files, please.

Comment 21 Thomas J. Baker 2004-10-12 15:56:03 EDT
I never had one and my other three fc3t3 systems don't either.
(They're all i386 though.) On the x86_64:

[root@nocona ~]# cd /etc
[root@nocona etc]# cd rpm
[root@nocona rpm]# ls
macros           macros.prelink  macros.up2date
macros.jpackage  macros.specspo  platform
[root@nocona rpm]# grep transaction *
macros:%_transaction_color   3
[root@nocona rpm]#

It's only found in the one I created.
Comment 22 Seth Vidal 2004-10-12 15:58:03 EDT
transaction color 3 is how you can have two files of different arch
types overwriting one another w/o a fit.

it should be set on every x86_64.

If you're getting conflicts then maybe it wasn't installed with
transaction_color 3 enabled.

Jeremy, is that possible?
Comment 23 Thomas J. Baker 2004-10-15 08:43:00 EDT
Is there any workaround or is my install basically hosed? I'd like to
do some x86_64 testing on this machine.
Comment 24 Thomas J. Baker 2004-10-15 14:36:47 EDT
I just found out that this machine is going away on Monday. If you
want me to test anything on it, it will have to be soon. 
Comment 25 Thomas J. Baker 2004-10-28 14:41:00 EDT
So I just installed FC3FC2 on new Precision 370 machine and I have the
same problem. Pointing it at rawhide, I can't upgrade hal due to file
conflicts just like above. I have two versions of hal installed (i386
and x86_64). I again don't have a /etc/rpm/macros file. 

What am I doing wrong?
Comment 26 Seth Vidal 2004-10-28 14:42:20 EDT
this is an ia32e, right?

If so I think we may have an answer, now.
Comment 27 Thomas J. Baker 2004-10-28 14:45:34 EDT
Yes. There's now a file in /etc/rpm called platform which says
"ia32e-redhat-linux".
Comment 28 Seth Vidal 2004-10-28 14:53:29 EDT
Yeah okay.

rpm -qpl yum | grep arch.py

replace that file with the one I will attach in a moment.

then run it again and tell me if it all looks better.

Comment 29 Seth Vidal 2004-10-28 14:54:23 EDT
Created attachment 105908 [details]
potential solution
Comment 30 Thomas J. Baker 2004-10-28 15:04:36 EDT
Unfortunately, it still fails exactly the same way:

root@scatterbrain tjb]# yum update
Setting up Update Process
Setting up Repo:  development
repomd.xml                100% |=========================| 1.1 kB    00:00
Reading repository metadata in from local files
developmen: ################################################## 3426/3426
Resolving Dependencies
--> Populating transaction set with selected packages. Please wait.
---> Package FreeWnn-libs.i386 1:1.10pl020-4 set to be updated
---> Package libxml2.i386 0:2.6.14-2 set to be updated
---> Package system-config-packages.noarch 0:1.2.20-1 set to be updated
---> Package hal.i386 0:0.4.0-9 set to be updated
---> Package fedora-logos.noarch 0:1.1.29-1 set to be updated
---> Package cups-libs.i386 1:1.1.22-0.rc1.8 set to be updated
--> Running transaction check

Dependencies Resolved
Transaction Listing:
  Update: FreeWnn-libs.i386 1:1.10pl020-4
  Update: cups-libs.i386 1:1.1.22-0.rc1.8
  Update: fedora-logos.noarch 0:1.1.29-1
  Update: hal.i386 0:0.4.0-9
  Update: libxml2.i386 0:2.6.14-2
  Update: system-config-packages.noarch 0:1.2.20-1
Is this ok [y/N]: y
Downloading Packages:
Running Transaction Test
Finished Transaction Test
Transaction Check Error:   file
/usr/share/hal/fdi/90defaultpolicy/storage-policy.fdi from install of
hal-0.4.0-9 conflicts with file from package hal-0.4.0-5
[root@scatterbrain tjb]#

Comment 31 Thomas J. Baker 2004-10-28 15:25:30 EDT
Do you want me to hold off on the "just change /etc/rpm/platform" fix
so that I can continue to test your potential fixes? I could probably
hold out until tomorrow morning but my co-worker is going to want her
machine soon. No big deal to wait until tomorrow though.
Comment 32 Seth Vidal 2004-10-28 15:30:31 EDT
wait a sec.

let's take a step back.

yum list updates hal\*

on an un-updated system

please.
Comment 33 Seth Vidal 2004-10-28 15:34:14 EDT
found it.

I'm going to be attaching one more new file.

then you should try it.

Comment 34 Seth Vidal 2004-10-28 15:36:20 EDT
Created attachment 105911 [details]
fix for updates and ia32e
Comment 35 Seth Vidal 2004-10-28 15:50:09 EDT
<sigh>
once more, with feeling.

See new, attached arch.py.

replace yours and test, please.
Comment 36 Seth Vidal 2004-10-28 15:51:22 EDT
Created attachment 105912 [details]
fix for ia32e basearch detection
Comment 37 Thomas J. Baker 2004-10-28 16:02:37 EDT
Still no go:

[root@scatterbrain rpmUtils]# ls -lrt
total 208
-rw-r--r--  1 root root 23146 Oct 21 13:27 updates.py
-rw-r--r--  1 root root 10604 Oct 21 13:27 transaction.py
-rw-r--r--  1 root root 10979 Oct 21 13:27 oldUtils.py
-rw-r--r--  1 root root 10590 Oct 21 13:27 miscutils.py
-rw-r--r--  1 root root  8997 Oct 21 13:27 __init__.py
-rw-r--r--  1 root root 16536 Oct 28 14:34 updates.pyc
-rw-r--r--  1 root root 10977 Oct 28 14:34 transaction.pyc
-rw-r--r--  1 root root 15648 Oct 28 14:34 oldUtils.pyc
-rw-r--r--  1 root root 10356 Oct 28 14:34 miscutils.pyc
-rw-r--r--  1 root root 11221 Oct 28 14:34 __init__.pyc
-rw-r--r--  1 root root  6609 Oct 28 16:05 arch.py
-rw-r--r--  1 root root  7474 Oct 28 16:05 arch.pyc
[root@scatterbrain rpmUtils]# yum -y update
Setting up Update Process
Setting up Repo:  development
repomd.xml                100% |=========================| 1.1 kB    00:00
Reading repository metadata in from local files
developmen: ################################################## 3426/3426
Resolving Dependencies
--> Populating transaction set with selected packages. Please wait.
---> Package FreeWnn-libs.i386 1:1.10pl020-4 set to be updated
---> Package libxml2.i386 0:2.6.14-2 set to be updated
---> Package system-config-packages.noarch 0:1.2.20-1 set to be updated
---> Package hal.i386 0:0.4.0-9 set to be updated
---> Package fedora-logos.noarch 0:1.1.29-1 set to be updated
---> Package cups-libs.i386 1:1.1.22-0.rc1.8 set to be updated
--> Running transaction check

Dependencies Resolved
Transaction Listing:
  Update: FreeWnn-libs.i386 1:1.10pl020-4
  Update: cups-libs.i386 1:1.1.22-0.rc1.8
  Update: fedora-logos.noarch 0:1.1.29-1
  Update: hal.i386 0:0.4.0-9
  Update: libxml2.i386 0:2.6.14-2
  Update: system-config-packages.noarch 0:1.2.20-1
Downloading Packages:
Running Transaction Test
Finished Transaction Test
Transaction Check Error:   file
/usr/share/hal/fdi/90defaultpolicy/storage-policy.fdi from install of
hal-0.4.0-9 conflicts with file from package hal-0.4.0-5
[root@scatterbrain rpmUtils]#
Comment 38 Thomas J. Baker 2004-10-28 16:03:21 EDT
[root@scatterbrain rpmUtils]# yum list updates hal\*
Setting up Repo:  development
repomd.xml                100% |=========================| 1.1 kB    00:00
Reading repository metadata in from local files
developmen: ################################################## 3426/3426
Updated Packages
hal.i386                                 0.4.0-9               
development
[root@scatterbrain rpmUtils]#
Comment 39 Seth Vidal 2004-10-28 16:12:27 EDT
hmm, okay
yum -d 4 list updates hal\*

Comment 40 Thomas J. Baker 2004-10-28 16:13:29 EDT
[root@scatterbrain rpmUtils]# yum -d 4 list updates hal\*
Yum Version: 2.1.10
COMMAND: yum -d 4 list updates hal*
Installroot: /
Ext Commands:
   updates
   hal*
Setting up Repo:  development
Baseurl(s) for repo: ['http://yum/fedora/development/x86_64/']
repomd.xml                100% |=========================| 1.1 kB    00:00
Reading repository metadata in from local files
Setting up Package Sacks
developmen: ################################################## 3426/3426
Reading Local RPMDB
Building updates object
Matching packages for package list to user args
Updated Packages
hal.i386                                 0.4.0-9               
development
[root@scatterbrain rpmUtils]#
Comment 41 Seth Vidal 2004-10-28 16:17:05 EDT
1. upgrade to yum 2.1.11 then reapply updates.py and arch.py from this bug
2. make sure your repository is synced from x86_64 completely.

Thanks.
Comment 42 Thomas J. Baker 2004-10-28 16:28:29 EDT
Mirror is synced. Upgraded to 2.1.11 and applied patches. Still no go:

[root@scatterbrain tmp]# rpm -Uvh yum-2.1.11-1.noarch.rpm
Preparing...               
########################################### [100%]
   1:yum                   
########################################### [100%]
[root@scatterbrain tmp]# cp arch.py
/usr/lib/python2.3/site-packages/rpmUtils/ cp: overwrite
`/usr/lib/python2.3/site-packages/rpmUtils/arch.py'? yes

[root@scatterbrain tmp]# cp updates.py
/usr/lib/python2.3/site-packages/rpmUtils/
cp: overwrite `/usr/lib/python2.3/site-packages/rpmUtils/updates.py'? yes
[root@scatterbrain tmp]# yum -y update
Setting up Update Process
Setting up Repo:  development
repomd.xml                100% |=========================| 1.1 kB    00:00
Reading repository metadata in from local files
developmen: ################################################## 3426/3426
Resolving Dependencies
--> Populating transaction set with selected packages. Please wait.
---> Package FreeWnn-libs.i386 1:1.10pl020-4 set to be updated
---> Package libxml2.i386 0:2.6.14-2 set to be updated
---> Package system-config-packages.noarch 0:1.2.20-1 set to be updated
---> Package hal.i386 0:0.4.0-9 set to be updated
---> Package fedora-logos.noarch 0:1.1.29-1 set to be updated
---> Package cups-libs.i386 1:1.1.22-0.rc1.8 set to be updated
--> Running transaction check

Dependencies Resolved
Transaction Listing:
  Update: FreeWnn-libs.i386 1:1.10pl020-4
  Update: cups-libs.i386 1:1.1.22-0.rc1.8
  Update: fedora-logos.noarch 0:1.1.29-1
  Update: hal.i386 0:0.4.0-9
  Update: libxml2.i386 0:2.6.14-2
  Update: system-config-packages.noarch 0:1.2.20-1
Downloading Packages:
Running Transaction Test
Finished Transaction Test
Transaction Check Error:   file
/usr/share/hal/fdi/90defaultpolicy/storage-policy.fdi from install of
hal-0.4.0-9 conflicts with file from package hal-0.4.0-5
[root@scatterbrain tmp]# yum -d 4 list updates hal\*
Yum Version: 2.1.11
COMMAND: yum -d 4 list updates hal*
Installroot: /
Ext Commands:
   updates
   hal*
Setting up Repo:  development
Baseurl(s) for repo: ['http://yum/fedora/development/x86_64/']
repomd.xml                100% |=========================| 1.1 kB    00:00
Reading repository metadata in from local files
Setting up Package Sacks
developmen: ################################################## 3426/3426
Reading Local RPMDB
Building updates object
Matching packages for package list to user args
Updated Packages
hal.i386                                 0.4.0-9               
development
[root@scatterbrain tmp]#

Comment 43 Seth Vidal 2004-10-28 16:31:01 EDT
can you send me the url to your yum repo so I can check something out
on it?
Comment 44 Seth Vidal 2004-10-28 16:34:09 EDT
if this is your repo then I know what's wrong.

there are no x86_64 packages here.

http://yum.sr.unh.edu/fedora/development/x86_64/Fedora/RPMS/
Comment 45 Thomas J. Baker 2004-10-28 16:42:21 EDT
http://yum.sr.unh.edu/fedora/development/ which is mirrored from
mirror.linux.duke.edu. I'm trying to figure out why my mirror isn't
mirroring the x86_64 rpms but in the meantime, I pointed yum at
mirror.linux.duke.edu:

[root@scatterbrain yum.repos.d]# yum -d 4 list updates hal\*
Yum Version: 2.1.11
COMMAND: yum -d 4 list updates hal*
Installroot: /
Ext Commands:
   updates
   hal*
Setting up Repo:  development
Baseurl(s) for repo:
['http://mirror.linux.duke.edu/fedora/pub/fedora/linux/core/development/x86_64/']
repomd.xml                100% |=========================| 1.1 kB    00:09
Reading repository metadata in from local files
Setting up Package Sacks
primary.xml.gz            100% |=========================| 1.0 MB    00:50
MD Read   : ################################################## 3635/3635
developmen: ################################################## 3635/3635
Reading Local RPMDB
Building updates object
Matching packages for package list to user args
Updated Packages
hal.i386                                 0.4.0-9               
development
[root@scatterbrain yum.repos.d]# yum -y update
Setting up Update Process
Setting up Repo:  development
repomd.xml                100% |=========================| 1.1 kB    00:11
Reading repository metadata in from local files
developmen: ################################################## 3635/3635
Resolving Dependencies
--> Populating transaction set with selected packages. Please wait.
---> Downloading header for up2date to pack into transaction set.
up2date-4.3.47-5.x86_64.r 100% |=========================|  66 kB    00:10
---> Package up2date.x86_64 0:4.3.47-5 set to be updated
---> Downloading header for python-devel to pack into transaction set.
python-devel-2.3.4-11.x86 100% |=========================|  60 kB    00:11
---> Package python-devel.x86_64 0:2.3.4-11 set to be updated
---> Downloading header for initscripts to pack into transaction set.
initscripts-7.93.2-1.x86_ 100% |=========================|  86 kB    00:09
---> Package initscripts.x86_64 0:7.93.2-1 set to be updated
---> Package hal.i386 0:0.4.0-9 set to be updated
---> Downloading header for cups-devel to pack into transaction set.
cups-devel-1.1.22-0.rc1.8 100% |=========================|  21 kB    00:11
---> Package cups-devel.x86_64 1:1.1.22-0.rc1.8 set to be updated
---> Package libxml2.i386 0:2.6.14-2 set to be updated
---> Downloading header for python to pack into transaction set.
python-2.3.4-11.x86_64.rp 100% |=========================| 190 kB    00:18
---> Package python.x86_64 0:2.3.4-11 set to be updated
---> Downloading header for cups to pack into transaction set.
cups-1.1.22-0.rc1.8.x86_6 100% |=========================|  94 kB    00:10
---> Package cups.x86_64 1:1.1.22-0.rc1.8 set to be updated
---> Package system-config-packages.noarch 0:1.2.20-1 set to be updated
---> Downloading header for NetworkManager to pack into transaction set.
NetworkManager-0.3.1-2.x8 100% |=========================| 8.2 kB    00:08
---> Package NetworkManager.x86_64 0:0.3.1-2 set to be updated
---> Package FreeWnn-libs.i386 1:1.10pl020-4 set to be updated
---> Downloading header for lvm2 to pack into transaction set.
lvm2-2.00.25-1.01.x86_64. 100% |=========================|  14 kB    00:07
---> Package lvm2.x86_64 0:2.00.25-1.01 set to be updated
---> Package fedora-logos.noarch 0:1.1.29-1 set to be updated
---> Downloading header for NetworkManager-gnome to pack into
transaction set.
NetworkManager-gnome-0.3. 100% |=========================| 7.5 kB    00:10
---> Package NetworkManager-gnome.x86_64 0:0.3.1-2 set to be updated
---> Downloading header for libxml2-python to pack into transaction set.
libxml2-python-2.6.14-2.x 100% |=========================| 9.3 kB    00:09
---> Package libxml2-python.x86_64 0:2.6.14-2 set to be updated
---> Package cups-libs.i386 1:1.1.22-0.rc1.8 set to be updated
---> Downloading header for up2date-gnome to pack into transaction set.
up2date-gnome-4.3.47-5.x8 100% |=========================|  41 kB    00:07
---> Package up2date-gnome.x86_64 0:4.3.47-5 set to be updated
---> Downloading header for libxml2-devel to pack into transaction set.
libxml2-devel-2.6.14-2.x8 100% |=========================|  42 kB    00:06
---> Package libxml2-devel.x86_64 0:2.6.14-2 set to be updated
--> Running transaction check

Dependencies Resolved
Transaction Listing:
  Update: FreeWnn-libs.i386 1:1.10pl020-4
  Update: NetworkManager.x86_64 0:0.3.1-2
  Update: NetworkManager-gnome.x86_64 0:0.3.1-2
  Update: cups.x86_64 1:1.1.22-0.rc1.8
  Update: cups-devel.x86_64 1:1.1.22-0.rc1.8
  Update: cups-libs.i386 1:1.1.22-0.rc1.8
  Update: fedora-logos.noarch 0:1.1.29-1
  Update: hal.i386 0:0.4.0-9
  Update: initscripts.x86_64 0:7.93.2-1
  Update: libxml2.i386 0:2.6.14-2
  Update: libxml2-devel.x86_64 0:2.6.14-2
  Update: libxml2-python.x86_64 0:2.6.14-2
  Update: lvm2.x86_64 0:2.00.25-1.01
  Update: python.x86_64 0:2.3.4-11
  Update: python-devel.x86_64 0:2.3.4-11
  Update: system-config-packages.noarch 0:1.2.20-1
  Update: up2date.x86_64 0:4.3.47-5
  Update: up2date-gnome.x86_64 0:4.3.47-5
Downloading Packages:
up2date-4.3.47-5.x86_64.r 100% |=========================| 1.3 MB    00:19
python-devel-2.3.4-11.x86 100% |=========================| 1.4 MB    00:13
initscripts-7.93.2-1.x86_ 100% |=========================| 1.1 MB    00:19
cups-devel-1.1.22-0.rc1.8 100% |=========================| 143 kB    00:05
python-2.3.4-11.x86_64.rp 100% |=========================| 5.0 MB    00:44
cups-1.1.22-0.rc1.8.x86_6 100% |=========================| 1.5 MB    00:27
NetworkManager-0.3.1-2.x8 100% |=========================|  93 kB    00:05
lvm2-2.00.25-1.01.x86_64. 100% |=========================| 821 kB    00:18
NetworkManager-gnome-0.3. 100% |=========================|  71 kB    00:07
libxml2-python-2.6.14-2.x 100% |=========================| 456 kB    00:07
up2date-gnome-4.3.47-5.x8 100% |=========================| 134 kB    00:08
libxml2-devel-2.6.14-2.x8 100% |=========================| 1.8 MB    00:21
Running Transaction Test
Finished Transaction Test
Transaction Check Error:   file
/usr/share/hal/fdi/90defaultpolicy/storage-policy.fdi from install of
hal-0.4.0-9 conflicts with file from package hal-0.4.0-5
[root@scatterbrain yum.repos.d]#
Comment 46 Seth Vidal 2004-10-28 16:45:07 EDT
and this is with both of the attached files overwriting the ones from
yum 2.1.11?



and using mirror.linux.duke.edu what do you get for a yum list updates
hal\*?
Comment 47 Seth Vidal 2004-10-28 16:45:53 EDT
ignore that second question.


sorry, I misread
Comment 48 Thomas J. Baker 2004-10-28 16:47:43 EDT
both are applied:

[root@scatterbrain rpmUtils]# ls -lrt
total 208
-rw-r--r--  1 root root 10604 Oct 28 00:11 transaction.py
-rw-r--r--  1 root root 10979 Oct 28 00:11 oldUtils.py
-rw-r--r--  1 root root 10590 Oct 28 00:11 miscutils.py
-rw-r--r--  1 root root  9098 Oct 28 00:11 __init__.py
-rw-r--r--  1 root root  6609 Oct 28 16:25 arch.py
-rw-r--r--  1 root root 10977 Oct 28 16:25 transaction.pyc
-rw-r--r--  1 root root 15648 Oct 28 16:25 oldUtils.pyc
-rw-r--r--  1 root root 10356 Oct 28 16:25 miscutils.pyc
-rw-r--r--  1 root root 11325 Oct 28 16:25 __init__.pyc
-rw-r--r--  1 root root  7474 Oct 28 16:25 arch.pyc
-rw-r--r--  1 root root 23143 Oct 28 16:28 updates.py
-rw-r--r--  1 root root 16545 Oct 28 16:29 updates.pyc
[root@scatterbrain rpmUtils]#
Comment 49 Seth Vidal 2004-10-28 17:31:31 EDT
okie doke. I think I got it this time.

And thanks for finding this. My tests on x86_64(opteron) would have
never turned this up.

Apply the new updates.py I will attach.
Comment 50 Seth Vidal 2004-10-28 17:32:36 EDT
Created attachment 105917 [details]
update with fix for multlib arch traversal for ia32e
Comment 51 Thomas J. Baker 2004-10-28 17:55:30 EDT
That did it. Thanks!

FWIW, my mirror actually had the x86_64 rpms but I had set up my
webserver to map every non i386 tree to the i386 one due to an old
problem I used to have. Yum would try to take noarch rpms from various
other non-i386 arches and I only used to mirror the i386 trees.  I've
recently added x86_64 but forgot to fix the web server config. I don't
know if it was a problem with the generated headers or what. Actually,
I'll take out the redirects for the other arches now to see if the
problem still exists with yum 2.1. I think I originally did it back
for FC1. Another bug for another day.

Thanks again.
Comment 52 Seth Vidal 2004-10-28 18:08:26 EDT
rock.

glad it looks fixed.

let me know if that changes, otherwise I'm closing this as fixed,
upstream.

And I'll attach a patch for this solution versus yum 2.1.11

Comment 53 Seth Vidal 2004-10-28 18:12:17 EDT
Created attachment 105923 [details]
patch to fix all the problems listed here. Patch is against yum 2.1.11
Comment 54 Seth Vidal 2004-10-30 23:32:59 EDT
Damn, patch doesn't quite fix it.

the patch breaks:
yum install foo.noarch.

It's a trivial fix.

Add the attached patch to the previous patch and the problem goes away.

Sorry folks.


Comment 55 Seth Vidal 2004-10-30 23:35:07 EDT
Created attachment 105988 [details]
fix for installation of noarch packages

Note You need to log in before you can comment on or make changes to this bug.